package noe.common.javatests.EjbviaHttpTest;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.util.Properties;

/**
 * @author Bogdan Sikora (bsikora@redhat.com)
 */
public class Client {

    public final static int TIMES = 10;

    public static void main(String[] args) throws NamingException {
        final String ADDR = System.getProperty("remote.server.address", "127.0.0.1:8080");
        final String PATH = System.getProperty("remote.endpoint.path", "/wildfly-services");
        final Boolean stateful = Boolean.getBoolean("stateful");
        final String URL = "http://" + ADDR + PATH;
        InitialContext iniCtx = new InitialContext(getCtxProperties(URL));
        String lookupName = (stateful) ?
                "ejb:/server/StatefulJvmRoute!noe.common.javatests.EjbviaHttpTest.EjbJvmRouteInterface?stateful" :
                "ejb:/server/StatelessJvmRoute!noe.common.javatests.EjbviaHttpTest.EjbJvmRouteInterface";
        EjbJvmRouteInterface bean = (EjbJvmRouteInterface)iniCtx.lookup(lookupName);
        try {
            for (int i = 0; i < TIMES; i++) {
                System.out.print(bean.getJvmroute() + ";");
            }
        } finally {
            iniCtx.close();
        }
    }

    public static Properties getCtxProperties(String URL) {
        Properties props = new Properties();
        props.put(Context.INITIAL_CONTEXT_FACTORY, "org.wildfly.naming.client.WildFlyInitialContextFactory");
        props.put(Context.PROVIDER_URL, URL);
        return props;
    }
}
